/******************************************************************************
 * vari/main.cpp = Datei-Kopf der Hauptdatei und deren Beschreibungen.        *
 * ========================================================================== *
 * Copyright by Hilfe & Service von EDV-Fachleuten      INet www.husvedvf.de  *
 *              Inhaber Harald Schrfer                 Tel. (0345) 521 13 40 *
 *              Reilstr. 22, (Eingang Mozartstr.)       Funk (0177) 521 13 40 *
 *                                                      EM   hsc@husvedvf.de  *
 *              D-06114 Halle (Saale)                   Fax  (0345) 521 13 41 *
 ******************************************************************************/

/******* Header-File for include loadet ***************************************/
#include "main.hpp"

using namespace std;

/******* Constant definieren **************************************************/
enum ZAEHLER {ZEICHEN=1, GANZZAHL, DRITTER, FUENFTER=5};   // Nummer des Variablentyps

/******* Simple sariable and object deklarieren *******************************/
int giFehler;   // Globale Fehlervariable fuer die Aufnahme und Auswertung.

/******* Object deklarieren ***************************************************/


/******************************************************************************
 * byt2bin = Byte to binaere.                                                 *
 ******************************************************************************/
char *byt2bit(unsigned char bX, char *pcaBit)
{
/******* Deklaration von Variablen ********************************************/
char
 caBit[10];   // Feld mit den 9 Zeichen, welches an den Zeiger pcaBit am Schlusz uebergeben wird.
int
 iI=0, iJ=0,   // Hilfszaehler.
 iL=8;   // Laenge  von etwas, z.B. die Bits in einem Byte.

/******* Die 8 Bit als 2 Tetrade bzw. Nibble ausgeben. ************************/
for (iI=0; iI < iL; iI++) {
 if (4 == iI) {   // An der 4. Stelle wird ein Leerzeichen als Trenner zwischen den 2 Nipple ausgegeben.
  caBit[iI+iJ]=' ';
  iJ++;
  }
 if (bX & 0x80) {
  caBit[iI+iJ]='1';
  }
 else {
  caBit[iI+iJ]='0';
  }
 bX <<= 1;
 }   // for (iI=0; iI<iL, iI++)
caBit[iI+iJ]='\0';
strcpy(pcaBit, caBit);
return pcaBit;
}   // char *byt2bit(unsigned char bX, char *pcaBit)


/******************************************************************************
 * main = Kopf der Hauptdatei und deren Beschreibungen                        *
 ******************************************************************************/
int main(int iArg, char* pcaArg[], char* pcEnv[])
{
/******* Definition von Konstanten ********************************************/

/******* Deklaration von Variablen ********************************************/
extern int giFehler;   // Siehe main.cpp!

char
 caBit[10], *pcaBit=caBit,  // Zeichenfeld fuer die Darstellung von 2 Tetraden + NULL
 cLW,   // Ein Zeichen im 8Bit ASCII fuer das Laufwerk.
 cZ,   // Ein Zeichen im 8Bit ASCII.
 caZk08[8],   // Zeichenkette/-feld mit maximal 7 Zeichen + NULL.
 caZk80[80];   // Zeichenkette/-feld mit maximal 79 Zeichen + NULL.

unsigned char
 bX=0x00,   // Hexadezimale Byte-Variable X = 00H.
 bY=0x00,   // Hexadezimale Byte-Variable Y = 00H.
 bZ=0x00;   // Hexadezimale Byte-Variable Z = 00H.

int
 iCelsius=23,   // Grad Celsius von 23C;
 *piCelsius=0,   // Zeiger auf eine Integer-Variable als NULL-Zeiger initialisiert.
 iFahrenheit=0,   // Fahrenheit, die andere Temperatureinheit.
 iFaktor=0,   // Faktor zwischen zwei Groeszen.
 iI=0, iJ=0,  // Hilfszaehler
 iL=0,   // Laenge
 iNr=0;   // Unsere Nummer fuer den Typ einer Variable.
float
 fCelsius=23.1,   // Grad Celsius von 23,1C
 *pfCelsius=nullptr,   // Zeiger auf eine FLOAT-Variable.
 fFahrenheit=0.1,   // Fahrenheit, die andere Temperatureinheit mit 0,1F initialisiert.
 fFaktor=0.2;   // Faktor mit 0.2 initialisiert.

struct sBITFELD {   // Feld mit 16 einzelenen Bits!
 unsigned int bitBasic:1;   // 00/15: Programm laeuft im Modus Basis: 7 Umlaute
 unsigned int bitA:1;   // 01/15: Alles;
 unsigned int bitH:1;   // 02/15: Hilfe
 unsigned int bitI:1;   // 03/15: Information
 unsigned int bitRest:12;   // Noch 16-(1+3) uebrig.
 } sBitFeld={1, 1, 0, 0, 0B101010101010};


/******* ZEICHEN **************************************************************/
iNr++;
cout << endl
     << iNr
     << ". = Character als Zeichen und -kette" << endl
     << "-------------------------------------" << endl;
strcpy(caZk08, "Hallo\0");
cZ='c';
iL=strlen(caZk08);
cout << "Gegeben: \n"
     << "- caZk08: " << caZk08 << " mit einer Laenge: " << iL << " und \n"
     << "- cZ: " << cZ << endl;
caZk08[2]=cZ;
cout << "- caZk08 mit cZ an der Position 2: " << caZk08 <<  endl;

/******* Ganzzahl *************************************************************/
iNr++;
cout << endl
     << iNr
     << ". = Integer als Ganzzahl" << endl
     << "-------------------------" << endl;
cout << "Temperatur in C als Ganzzahl einlesen? 0, 1, ..., ?: ";
cin >> iCelsius;

piCelsius=&iCelsius;
iFaktor=212-23;
iFahrenheit=iFaktor*iCelsius/100 + 23;   // 66,47
cout << "Gegeben: \n";
cout << "Temperatur in "
     << iCelsius << "C bzw. "
     << iFahrenheit << "F" << endl;
cout << "Gesucht: Groesze von\n";
cout << "- iCelsius: " << sizeof(iCelsius) << "Byte als Variable und \n"
     << "- piCelsius: " << sizeof(piCelsius) << "Byte als Zeiger auf\n"
     << "- *piC...: " << *piCelsius << " als Inhalt!"
     << endl;

/******* Flieskommazahl *******************************************************/
iNr++;
cout << endl;
cout << iNr
     << ". = Float als Flieszkommazahl" << endl
     << "------------------------------" << endl;
cout << "Temperatur in C als Flieszkommazahl einlesen? 0.0, 0.1, ..., ?: ";
// std::cin.sync();
cin.clear();
fflush(stdin);   // Falls zuvor keine Zahl sondern ein Buchstabe eingegeben worde, hilft dies!
// std::cin.ignore(std::numeric_limits<std::streamsize>::max(), '\n');
// cin.ignore();
cin >> fCelsius;

pfCelsius=&fCelsius;
fFaktor=(212.0-23.0)/100;
fFahrenheit=fFaktor*fCelsius+23;   // 66,47
cout << "Gegeben: Temperatur in "
     << fCelsius << "C bzw. "
     << fFahrenheit << "F" << endl;
cout << "Gesucht: Groesze von\n";
cout << "- fCelsius: " << sizeof(fCelsius) << "Byte als Variable und \n"
     << "- pfCelsius: " << sizeof(pfCelsius) << "Byte als Zeiger auf \n"
     << "- *pfC...: " << *pfCelsius << " als Inhalt." << endl;

/******* Bit-Feld *************************************************************/
iNr++;
cout << endl
     << iNr
     << ". = Bitfeld als Struktur mit 16Bit fuer Schaltanwendungen" << endl
     << "----------------------------------------------------------" << endl;
sBitFeld.bitBasic=0;
cout << "- bitBasic: " << sBitFeld.bitBasic << endl;
cout << "- bitA fuer Alles: " << sBitFeld.bitA << endl;
cout << "- bitH fuer Hilfe: " << sBitFeld.bitH << endl;
cout << "- bitI fuer Information: " << sBitFeld.bitI << endl;

cout << "Gesucht: Groesze " << iL << endl;
iL=sizeof(sBitFeld);
cout << "- Bit-Feld: " << iL << "Byte" << endl;

/******* Bedingtes Debuggen und Stop wenn das Laufwerk == C ist! **************/
iNr++;
cout << endl
     << iNr
     << ". = Bedingtes Debuggen und Stop wenn das Laufwerk == C ist!" << endl
     << "------------------------------------------------------------" << endl;
cout << "Zeichen: " << endl;
for (cLW='\0'; cLW < 'Z'; cLW++) {
 cZ=cLW;
 cout << "- " << cZ << endl;
 }   // for (cLW='\0'; cLW < 'Z'; cLW++)

/******* Logisch bineare Operationen ******************************************/
iNr++;
cout << endl
     << iNr
     << ". Logisch bineare Operationen" << endl
     << "------------------------------" << endl;
bX=0x07;
bY=0x1F;
cout << "Gegeben: " << endl;
sprintf(caZk80, "- bX = %2.2xH = ", bX);
cout << caZk80 << byt2bit(bX, pcaBit) << "B" << endl;
sprintf(caZk80, "- bY = %2.2xH = ", bY);
cout << caZk80 << byt2bit(bY, pcaBit) << "B" << endl;

cout << "Aufgabe und Ergebnis: " << endl;
cout << "- NOT bX = " << byt2bit((unsigned char) ~bX, pcaBit) << "B;" << endl;
cout << "- NOT bY = " << byt2bit((unsigned char) ~bY, pcaBit) << "B;" << endl;

bZ=bX & bY;
cout << "- bX UND bY = " << byt2bit(bZ, pcaBit) << "B;" << endl;

bZ=bX | bY;
cout << "- bX OR bY = " << byt2bit(bZ, pcaBit) << "B;" << endl;

bZ=bX ^ bY;
cout << "- bX XOR bY = " << byt2bit(bZ, pcaBit) << "B;" << endl;

/******* Verschieb Operationen ************************************************/
iNr++;
cout << endl
     << iNr
     << ". Verschiebe Operationen" << endl
     << "-------------------------" << endl;
bX=0x07;
bY=0x1F;
cout << "Gegeben: " << endl;
sprintf(caZk80, "- bX = %2.2xH = ", bX);
cout << caZk80 << byt2bit(bX, pcaBit) << "B" << endl;
sprintf(caZk80, "- bY = %2.2xH = ", bY);
cout << caZk80 << byt2bit(bY, pcaBit) << "B" << endl;

cout << "Aufgabe und Ergebnis: " << endl;
bZ=bX << 3;
cout << "- Links Schieben der Bits um 3 Stellen mit (bX << 3) = "
     << byt2bit((unsigned char) bZ, pcaBit) << "B;" << endl;
bZ=bY >> 2;
cout << "- Rechts Schieben der Bits um 2 Stellen mit (bY >> 2) = "
     << byt2bit((unsigned char) bZ, pcaBit) << "B;" << endl;

/******* Logische Operationen *************************************************/
iNr++;
cout << endl
     << iNr
     << ". Logische Operationen" << endl
     << "-----------------------" << endl;
iI=+9;
iJ=0;
iL=-4;
cout << "Gegeben: " << endl
     << " 1. positive Zahl iI = " << iI << endl
     << " 2. NULL-Zahl     iJ = " << iJ << endl
     << " 3. negative Zahl iL = " << iL << endl;
cout << "Aufgabe und Ergebnis: " << endl;
cout << "- Logisches NOT von " << endl
     << "  - iI = " << (!iI) << endl
     << "  - iJ = " << (!iJ) << endl
     << "  - iL = " << (!iL) << endl;
cout << "- Logisches UND von " << endl
     << "  - iI UND iJ = " << (iI && iJ) << endl
     << "  - iI UND iL = " << (iI && iL) << endl
     << "  - iJ UND iL = " << (iJ && iL) << endl;
cout << "- Logisches OR von " << endl
     << "  - iI OR iJ = " << (iI || iJ) << endl
     << "  - iI OR iL = " << (iI || iL) << endl
     << "  - iJ OR iL = " << (iJ || iL) << endl;
cout << "- Logisches XOR von " << endl
     << "  - iI XOR iJ = " << (iI != iJ) << endl
     << "  - iI XOR iL = " << (iI != iL) << endl
     << "  - iJ XOR iL = " << (iJ != iL) << endl
     << "  - iL XOR iL = " << (iL != iL) << endl;

/******** Funktion schlieszen *************************************************/
iNr++;
cout << endl
     << iNr
     << ". Programm schlieszen und pruegen ob ein Fehler aufgetreten ist!"
     << endl;
cout << "Eigenen Fehler-Nummer eingeben: ";
cin >> giFehler;
if (0 != giFehler) {
 cerr << endl
      << "Ein Fehler ist aufgetreten!" << endl
      << giFehler << ": ";
 switch (giFehler)
  {
  case 0x001:
   cerr << "Eins = Noch nicht bezeichnet." << endl;
   break;
  case 0x00FF:
   cerr << "Zeihundertfuenfundfuenfzig = Noch nicht bezeichnet." << endl;
   break;
  default:
   cerr << "Unbekannter Fehler! Bitte melden." << endl;
   break;
  }
 cerr << endl;
 }   // if (0 != giFehler)
else
 cout << endl << "Danke fuer die Nutzung des Programms VARI v1.022! H&S<-EDV"
      << endl;

cout << "\n\nEnde bestaetigen! ";
cZ=getch();
return giFehler;
}   // int main(int iArg, char* pcaArg[], char* pcEnv[])
/******** EOF *****************************************************************/
